unit Internet;

interface

uses
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
    ExtCtrls, StdCtrls, ComCtrls, OleCtrls, MSWinsockLib_TLB;

type
  TfrmInternet = class(TForm)
    StaticText1: TStaticText;
    btnCancel: TButton;
    btnNew: TButton;
    btnJoin: TButton;
    Shape1: TShape;
    Label1: TLabel;
    lblYourIP: TLabel;
    StatusBar1: TStatusBar;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    txtHostIP: TEdit;
    btnConnect: TButton;
    btnBack: TButton;
    Label5: TLabel;
    GroupBox1: TGroupBox;
    Bevel1: TBevel;
    procedure btnNewClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnJoinClick(Sender: TObject);
    procedure btnBackClick(Sender: TObject);
    procedure btnConnectClick(Sender: TObject);

  private
    { Private declarations }
    procedure HideAll();
    procedure UnhideNew();
    procedure UnhideJoin();
  public
    { Public declarations }
    CancelPressed : Boolean;
    State : Integer; //0-Cancel, 1-Host, 2-Join
    DataString : WideString;    
  end;

var
  frmInternet: TfrmInternet;

implementation

uses
        Battleship;
{$R *.DFM}

procedure TfrmInternet.btnNewClick(Sender: TObject);
begin
        HideAll();
        State := 1; //Host
        UnhideNew();
        BattleShip.PlayerName[1] := InputBox('Name','Enter PlayerName:','Player1');
        Battleship.FrmBattleShip.TCPClient.Enabled := False;

        Battleship.FrmBattleShip.TCPServer.Enabled := True;
        Battleship.FrmBattleShip.TCPServer.LocalPort := 6;
        lblYourIP.Caption := Battleship.FrmBattleShip.TCPServer.LocalIP;

        StatusBar1.SimpleText := 'Waiting for other players...';
        if Battleship.FrmBattleShip.TCPServer.State <> sckClosed then Battleship.FrmBattleShip.TCPServer.Close;
        Battleship.FrmBattleShip.TCPServer.Listen;
        StatusBar1.SimpleText := 'Listening...';
end;

procedure TfrmInternet.btnJoinClick(Sender: TObject);
begin
        HideAll();
        State := 2; //Join
        UnhideJoin();

        //set name
        BattleShip.PlayerName[2] := InputBox('Name','Enter PlayerName:','Player2');

        StatusBar1.SimpleText := 'Enter friends IP to join.';
        Battleship.FrmBattleShip.TCPServer.Enabled := False;
        Battleship.FrmBattleShip.TCPClient.Enabled := True;
        //Connect
end;

procedure TfrmInternet.HideAll();
begin
    btnNew.Visible := False;
    btnBack.Visible := False;
    btnBack.Visible := False;
    btnJoin.Visible := False;
    Label1.Visible := False;
    lblYourIP.Visible := False;
    Label2.Visible := False;
    Label3.Visible := False;
    Label4.Visible := False;
    Label5.Visible := False;
    txtHostIP.Visible := False;
    btnConnect.Visible := False;
    GroupBox1.Visible :=False;
end;

procedure TfrmInternet.UnhideNew();
begin
    Label1.Visible := True;
    lblYourIP.Visible := True;
    Label2.Visible := True;
    Label3.Visible := True;
    btnBack.Visible := True;
    btnCancel.Visible := False;
end;

procedure TfrmInternet.UnhideJoin();
begin
    Label4.Visible := True;
    Label5.Visible := True;
    txtHostIP.Visible := True;
    btnConnect.Visible := True;
    btnBack.Visible := True;
    btnCancel.Visible := False;
end;
procedure TfrmInternet.btnCancelClick(Sender: TObject);
begin
    GameMode := gmNone;
    CancelPressed := True;
    State := 0;
    Close();
end;

procedure TfrmInternet.FormShow(Sender: TObject);
begin
     HideAll();
     btnNew.Visible := True;
     btnJoin.Visible := True;
     GroupBox1.Visible :=True;
     btnCancel.Visible := True;
     StatusBar1.SimpleText := 'Ready.';
end;

procedure TfrmInternet.btnConnectClick(Sender: TObject);
begin
        StatusBar1.SimpleText := 'Connecting...';
        if Battleship.FrmBattleShip.TCPClient.State <> sckClosed then Battleship.FrmBattleShip.TCPClient.Close;
        try
                Battleship.FrmBattleShip.TCPClient.Connect(txtHostIP.Text,6);
        except
                Application.MessageBox('Cannot connect.  Wrong IP or opponent is not ready','Error',MB_OK);
                StatusBar1.SimpleText := 'Connection rejected';
        end;
end;

procedure TfrmInternet.btnBackClick(Sender: TObject);
begin
     HideAll();
     btnNew.Visible := True;
     btnJoin.Visible := True;
     GroupBox1.Visible :=True;
     btnCancel.Visible := True;
     StatusBar1.SimpleText := 'Canceled.';

     if Battleship.FrmBattleShip.TCPServer.State <> sckClosed then Battleship.FrmBattleShip.TCPServer.Close;
     if Battleship.FrmBattleShip.TCPClient.State <> sckClosed then Battleship.FrmBattleShip.TCPClient.Close;
end;
end.
